/* GCC */

#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>
#include <cmath>

using namespace std;

int n, m, d, dMain;
__int64 minN=pow(10, 18), maxN=0;
__int64 minM=pow(10, 18), maxM=0;
vector<int> lvlN, lvlM;
vector<int> prevLvlN, prevLvlM;

void show(vector<int> a){
	for(int i=0; i<a.size(); i++){
		cout<<a[i]<<' ';
	}
	cout<<endl;
}

int findNumByLvlN(int lvl){
	int i, z;
	for(i=0; i<n; i++){
		if(prevLvlN[i]==lvl){
			prevLvlN[i]=0;
			return i+1;
		}
	}
}
int findNumByLvlM(int lvl){
	int i, z;
	for(i=0; i<m; i++){
		if(prevLvlM[i]==lvl){
			prevLvlM[i]=0;
			return i+1;
		}
	}
}

int getAmmount(int dif){
	int i, z, j, sum=0;
	int lastPlayed=-1;
	for(i=0; i<n; i++){
		for(z=lastPlayed+1; z<m; z++){
			if(abs(lvlM[z]-dif-lvlN[i])<=d){
				lastPlayed=z;
				sum++;
				break;
			} else if (lvlM[z]>lvlN[i]) break;
		}
	}
	return sum;
}

int main(){
    ifstream fin("chess.in");
    ofstream fout("chess.out");

    fin>>n>>m>>d;

    //pairs=vector< vector<int> >();
    dMain=d;
    int i, z;
    lvlN=vector<int>(n);
    lvlM=vector<int>(m);

    //reading and finding max min
    for(i=0; i<n; i++){
		fin>>lvlN[i];
		if(lvlN[i]<minN) minN=lvlN[i];
		if(lvlN[i]>maxN) maxN=lvlN[i];
    }
    for(i=0; i<m; i++){
		fin>>lvlM[i];
		if(lvlM[i]<minM) minM=lvlM[i];
		if(lvlM[i]>maxM) maxM=lvlM[i];
    }

    //filling prev arrays
    prevLvlN=lvlN;
    prevLvlM=lvlM;

    //sorting
    sort(lvlN.begin(), lvlN.end());
    sort(lvlM.begin(), lvlM.end());



	//starting pos
    int currAm=getAmmount(0);
    int bestAm=currAm;
    int bestD=0;

    //checking all d
    for(i=minM-maxN-d ; i<=maxM-minN+d ; i++){
		currAm=getAmmount(i);
		if(currAm>bestAm){
			bestAm=currAm;
			bestD=i;
		}
    }


    //file out
    fout<<bestAm<<' '<<bestD<<endl;
    int lastPlayed=-1;
    for(i=0; i<n; i++){
		for(z=lastPlayed+1; z<m; z++){
			if(abs(lvlM[z]-bestD-lvlN[i])<=d){
				lastPlayed=z;
				fout<<findNumByLvlN(lvlN[i])<<' ';
				fout<<findNumByLvlM(lvlM[z])<<endl;
				break;
			} else if (lvlM[z]>lvlN[i]) break;
		}
	}



    fin.close();
    fout.close();
    return 0;
}
